function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useState } from 'react';
import useNode from './useNode';
import { Form, Checkbox, Input, Select } from 'antd';
import ConfigLoading from './configLoading';
import ColumnSelect from '../../../../components/columnSelect';
import { getFieldNameError } from './utils';
import '../styles/mergeColumn.less';
import _ from 'lodash';
// 合并列
var MergeColumnConfig = function MergeColumnConfig(_ref) {
  var node = _ref.node,
    nodeList = _ref.nodeList;
  var classPrefix = 'mergeColumn-config';
  var nodeData = node.getData();
  var _useState = useState(nodeData.label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState3 = useState((nodeData === null || nodeData === void 0 ? void 0 : nodeData.mergeList) || []),
    _useState4 = _slicedToArray(_useState3, 2),
    selectColumns = _useState4[0],
    setSelectColumns = _useState4[1];
  var _useState5 = useState(_objectSpread(_objectSpread({}, nodeData), {}, {
      separator: (nodeData === null || nodeData === void 0 ? void 0 : nodeData.customSeparator) ? 'custom' : nodeData === null || nodeData === void 0 ? void 0 : nodeData.separator
    })),
    _useState6 = _slicedToArray(_useState5, 2),
    formValue = _useState6[0],
    setFormValue = _useState6[1];
  var _useState7 = useState(nodeData.retain || false),
    _useState8 = _slicedToArray(_useState7, 2),
    retain = _useState8[0],
    setRetain = _useState8[1];
  var statusHandle = function statusHandle() {
    if (actName && selectColumns.length && formValue.fieldName && (formValue.separator !== 'custom' || formValue.separator === 'custom' && formValue.customSeparator)) {
      return true;
    } else {
      return false;
    }
  };
  useEffect(function () {
    node.updateData(_objectSpread(_objectSpread({
      mergeList: selectColumns,
      status: statusHandle() ? 'success' : 'failed'
    }, formValue), {}, {
      retain: retain,
      label: actName,
      separator: formValue.separator === 'custom' ? formValue.customSeparator : formValue.separator
    }));
  }, [selectColumns, formValue, retain, actName]);
  var onValuesChange = function onValuesChange(_value, allData) {
    setFormValue(_objectSpread({}, allData));
  };
  if (loading) {
    return /*#__PURE__*/React.createElement(ConfigLoading, null);
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement(Form, {
    labelCol: {
      span: 2
    },
    wrapperCol: {
      span: 12
    },
    onValuesChange: onValuesChange,
    initialValues: _objectSpread(_objectSpread({}, formValue), {}, {
      separator: (formValue === null || formValue === void 0 ? void 0 : formValue.separator) ? formValue === null || formValue === void 0 ? void 0 : formValue.separator : ''
    })
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0")), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    name: "fieldName",
    colon: false,
    rules: [{
      validator: function validator(_, value) {
        if (value === '') {
          return Promise.reject(new Error('请输入字段名称'));
        }
        if (getFieldNameError(nodeList, columnList, value, nodeData) || value == formValue.alias && value !== '') {
          return Promise.reject(new Error('字段名称已存在'));
        }
      }
    }]
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u6CE8\u91CA",
    name: "alias",
    colon: false
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u6CE8\u91CA",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u9009\u62E9\u5408\u5E76\u5B57\u6BB5",
    colon: false
  }, /*#__PURE__*/React.createElement(ColumnSelect, {
    options: columnList.filter(function (item) {
      return ['number', 'string'].includes(item.webType);
    }),
    value: selectColumns,
    onChange: setSelectColumns,
    max: 5,
    selectAll: true
  }), /*#__PURE__*/React.createElement(Checkbox, {
    onChange: function onChange(e) {
      return setRetain(e.target.checked);
    }
  }, "\u4FDD\u7559\u539F\u5B57\u6BB5")), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u5206\u9694\u7B26",
    name: "separator",
    colon: false,
    rules: [{
      required: true,
      message: '请选择分隔符'
    }]
  }, /*#__PURE__*/React.createElement(Select, {
    options: [{
      label: '无',
      value: ''
    }, {
      label: '；',
      value: ';'
    }, {
      label: '，',
      value: ','
    }, {
      label: '/',
      value: '/'
    }, {
      label: '-',
      value: '-'
    }, {
      label: '自定义',
      value: 'custom'
    }]
  })), formValue.separator === 'custom' && /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u81EA\u5B9A\u4E49\u5206\u9694\u7B26",
    name: "customSeparator",
    colon: false,
    rules: [{
      required: true,
      message: '请输入自定义分隔符'
    }],
    getValueFromEvent: function getValueFromEvent(event) {
      return event.target.value.replace(/\s+/g, '');
    }
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u81EA\u5B9A\u4E49\u5206\u9694\u7B26",
    maxLength: 5,
    showCount: true
  }))));
};
export default MergeColumnConfig;